# Armbian u-boot install script for linux-u-boot-odroidm1-current 2025.01-S6d41-Pee19-H4cab-V390e-Bb703-R448a
# This file provides functions for deploying u-boot to a block device.
DIR=/usr/lib/linux-u-boot-current-odroidm1
write_uboot_platform () 
{ 
    dd if=${1}/u-boot-rockchip.bin of=${2} bs=32k seek=1 conv=fsync
}
write_uboot_platform_mtd () 
{ 
    declare -a extra_opts_flashcp=("--verbose");
    if flashcp -h | grep -q -e '--partition'; then
        echo "Confirmed flashcp supports --partition -- read and write only changed blocks." 1>&2;
        extra_opts_flashcp+=("--partition");
    else
        echo "flashcp does not support --partition, will write full SPI flash blocks." 1>&2;
    fi;
    flashcp "${extra_opts_flashcp[@]}" "${1}/idbloader-spi.img" /dev/mtd0;
    flashcp "${extra_opts_flashcp[@]}" "${1}/u-boot.itb" /dev/mtd2;
    if fw_printenv | grep -q -i petitboot; then
        echo "Found traces of Petitboot in SPI u-boot environment, clearing SPI environment..." 1>&2;
        flash_erase /dev/mtd1 0 0;
    fi
}
setup_write_uboot_platform () 
{ 
    if grep -q "ubootpart" /proc/cmdline; then
        local tmp part dev;
        tmp=$(cat /proc/cmdline);
        tmp="${tmp##*ubootpart=}";
        tmp="${tmp%% *}";
        [[ -n $tmp ]] && part=$(findfs PARTUUID=$tmp 2> /dev/null);
        [[ -n $part ]] && dev=$(lsblk -n -o PKNAME $part 2> /dev/null);
        [[ -n $dev ]] && DEVICE="/dev/$dev";
    fi
}
